unit vv_guimain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, TntStdCtrls, vv;

type
  TForm1 = class(TForm)
    DebugMemo: TTntMemo;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Label2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   procedure Debug(S : WideString);
  end;

var
  Form1: TForm1;

implementation

uses Debug, vv_io, vfs, libext2fs, vv_common, vfs_ext2, vfs_mem, shellapi;

{$R *.DFM}

procedure TForm1.Debug(S : WideString);
begin
   DebugMemo.Lines.Add(S);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   fs2 : TMemFs;
begin
   SetDebugW(Debug);
   Show;
   Setup;

   fs2   := TMemFs.Create;
   Root  := fs2.Mount('');
   pwd   := Root;//.Open;

   if Assigned(pwd) then
   begin
      // script
      if FileExists('init.vv') then
      begin
         process_command('source win32 init.vv');
      end
      else
      begin
         process_command('scan');
      end;
   end;
   Edit1.SetFocus;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
   if Key = #13 then
   begin
      Key := #0;
      if not process_command(Edit1.Text) then close;
      Log('[ ' + pwd.Name + ']$ ');
      edit1.text := '';
//      label1.Caption := IntToStr(NodeCount);
   end;
end;

procedure TForm1.Label2Click(Sender: TObject);
begin
   ShellExecute(Handle, 'open', PChar(TLabel(Sender).Caption), nil, nil, SW_SHOWNORMAL)
end;

end.
