unit Unicode;

interface

function Encode(S : String) : WideString;
procedure SetUnicodeConversion(Enable : Boolean);

implementation

uses TntSystem;

var
ConvertUTF8ToWideString : Boolean;

procedure SetUnicodeConversion(Enable : Boolean);
begin
   ConvertUTF8ToWideString := Enable;
end;

function Encode(S : String) : WideString;
begin
   if ConvertUTF8ToWideString then
   begin
      Result := UTF8ToWideString(S);
   end
   else
   begin
      Result := S;
   end;
end;

end.
